--script adds a gainer at the beginning and the end of a DSP chain to drive it by the renoise
--set track headroom adjustment, then re-adjust for post track processing
--i.e. if the global headroom is -6dB the first gainer is + 6db and the second -6db

--keybinding
renoise.tool():add_keybinding {
  name = "Global:Tools:Add Headroom Compensating Gainers",
  invoke = function()add_gainers()
  end  
}

function add_gainers()
  --song object
  local song = renoise.song()
  
  --first headroom compensating gainer inserted at pos 2 (track vol pan always at pos 1)
  local gainer_device = song.selected_track:insert_device_at("Audio/Effects/Native/Gainer", 2)
  gainer_device.display_name = "Headroom Boost"
  --set volume 1/headroom
  gainer_device:parameter(1).value = (1/song.transport.track_headroom) --math.lin2db
  --hide volume slider in mixer
  gainer_device:parameter(1).show_in_mixer = false
  --minimize in DSP lane
  gainer_device.is_maximized = false

    
  --insert re-adjusting gainer to get pre track levels
  local gainer_device_2 = song.selected_track:insert_device_at("Audio/Effects/Native/Gainer", #song.selected_track.devices + 1)
  gainer_device_2.display_name = "Headroom Reset"
  --set volume to (+) headroom
  gainer_device_2:parameter(1).value = (song.transport.track_headroom) --math.db2lin
  --hide volume slider in mixer
  gainer_device_2:parameter(1).show_in_mixer = false
  --minimize in DSP lane
  gainer_device_2.is_maximized = false

end
